<?php /* 2002.08.17
 * Autor: Vctor P. Arissa <varissa@igijon.com> siguiendo la estructura
 * general de Javier Linares <javier@javierlinares.com>
 * Descripcin: Interfaz de propuestas de gadgets de portada espiraleras
 *
 * Dependencias: include/gadgets, ambulacro/form/gadgets.nuevafrase.form,
 * gadgets.nuevaimagen.form, includes habituales (sql, general)
*/

/* (c) 2002 La Espiral <info@lawebespiral.org>
 * (c) 2002 Vctor P. Arissa <varissa@igijon.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

/********** Inicio del programa principal gadgetsnuevos.php **********/

require("c:/ARCHIVOS DE PROGRAMA/APACHE GROUP/APACHE/HTDOCS/LAWEBESPIRAL/espiral.php");
$nivelAcceso = "0";
if(($rowUsuario=estasLogeadoBackoffice($nivelAcceso))<0) {
	exit();
}
require("layout.cabecera.php");

// Barra con enlaces
	$nombres[] = 'inicio';
	$enlaces[] = $PHP_SELF;
	$nombres[] = 'nueva frase espiralera';
	$enlaces[] = $PHP_SELF.'?action=nueva_frase';
	$nombres[] = 'nueva imagen espiralera';
	$enlaces[] = $PHP_SELF.'?action=nueva_imagen';
	$nombres[] = 'frases actuales';
	$enlaces[] = $PHP_SELF.'?action=ver_frases';
	$nombres[] = 'imgenes actuales';
	$enlaces[] = $PHP_SELF.'?action=ver_imagenes';
	// Si el usuario tiene los mismos privilegios que para
	// gadgets aprobar, tambien le presentamos este men
	if(estasLogeadoBackoffice(10)>=0)
	{
	  $nombres[] = 'sistema de aprobacin';
	  $enlaces[] = 'gadgetsaprobar.php';
	}
	menu($colorBO1, $colorBO2, "sistema de propuesta de nuevos gadgets de portada", $PHP_SELF, $nombres, $enlaces, $ruta_imagen, $rowUsuario);

// Control de flujo de las acciones. A partir de aqui va el codigo de la pagina 
	salto(2);
	print('</center>');
	fuente_inicio(2);

        // El formulario hace referencia a este mismo
	// fichero php, pero con la accion "nueva_frase_submit"
	if($action=="nueva_frase")
	   include('form/gadgets.nuevafrase.form');
	
	elseif($action=="nueva_frase_submit") 
	   introducir_nueva_frase($palabraE,$palabraS,$palabraP,$palabraI,
				  $palabraR,$palabraA,$palabraL);

        // El formulario hace referencia a este mismo
	// fichero php, pero con la accion "nueva_imagen_submit"
	elseif($action=="nueva_imagen")
	   include('form/gadgets.nuevaimagen.form');

	elseif($action=="nueva_imagen_submit")
	   introducir_nueva_imagen($fraseimagen,$fichero,$fichero_name,
	                           $fichero_type,$fichero_size);  		

	elseif ($action=='ver_frases')
	{
	 muestra_frases('e_gadgets_frases','Frases E.S.P.I.R.A.L. actuales');
	 muestra_frases('e_gadgets_profrases','Frases E.S.P.I.R.A.L. propuestas');
	}
	elseif ($action=='ver_imagenes')
	{
	 muestra_imagenes('e_gadgets_imagenes',$dirimgportada,'Imgenes E.S.P.I.R.A.L. actuales');
	 muestra_imagenes('e_gadgets_proimagenes',$dirimgpropuestas,'Imgenes E.S.P.I.R.A.L. propuestas');
	}

	else explicacion_inicial();

	fuente_fin();
	require ("layout.pie.php");
	
/********** Fin del programa principal gadgetsnuevos.php **********/
	
/*******************************************************************
	FUNCIONES
*******************************************************************/	
/*
   Introduce una nueva frase propuesta por un usuario en la tabla
de propuestas, siempre y cuando los datos pasados sean correctos.
*/
function introducir_nueva_frase($palabraE,$palabraS,$palabraP,$palabraI,
				$palabraR,$palabraA,$palabraL)
{
	global $rowUsuario;
	
	// A todas las cadenas PHP ya les ha aplicado la funcion
	// addslashes. Si se quiere invertir: stripslashes
		
	$todoCorrecto=compruebaletra($palabraE,'e');
	$todoCorrecto=$todoCorrecto && compruebaletra($palabraS,'s');
	$todoCorrecto=$todoCorrecto && compruebaletra($palabraP,'p');
	$todoCorrecto=$todoCorrecto && compruebaletra($palabraI,'i');
	$todoCorrecto=$todoCorrecto && compruebaletra($palabraR,'r');
	$todoCorrecto=$todoCorrecto && compruebaletra($palabraA,'a');
	$todoCorrecto=$todoCorrecto && compruebaletra($palabraL,'l');

	if(!$todoCorrecto)
	{
	  salto();
	  print('Por favor, introduzca bien las palabras');
	  salto();
	  return;
	}
	// Podemos introducirlo en la base de datos si no es demasiada larga
	$frase=$palabraE . ' ' . $palabraS . ' ' . $palabraP . ' ' .
	       $palabraI . ' ' . $palabraR . ' ' . $palabraA . ' ' .
	       $palabraL;
	// Hay alguna manera en SQL de saber el tamao maximo de
	// un campo? mysql_fetch_lenghts?
	if (strlen($frase)>255)
	{
	  print('La frase es demasiado larga (mas de 255 caracteres introducidos)<br>');
	  return;
	}
	// No hace falta addslashes porque ya viene hecho
	$result=crearRegistro('e_gadgets_profrases','frase,user_id',"'$frase','$rowUsuario[user_id]'");
	if(!$result)
	{
	  print('Fallo en el envo de la frase <b>'.stripslashes($frase).'</b>');
	  error_sql_traza(__FILE__, __LINE__);
	  return;
	}
        print('Frase <b>'.stripslashes($frase).'</b> aadida a la cola de propuestas.<br>');
 	print('Gracias por su colaboracin, <b>'.$rowUsuario[username].'</b><br>');
 	print('El equipo administrador estudiar la propuesta lo antes posible y le informar de la decisin tomada.');
	salto(2);
}
/*
   Introduce una nueva imagen propuesta por un usuario en la tabla
de propuestas, siempre y cuando los datos pasados sean correctos.
*/
function introducir_nueva_imagen($fraseimagen,$fichero,$fichero_name,
			         $fichero_type,$fichero_size)
{
	global $php_errormsg, $rowUsuario,$maxtamimg,$dirimgpropuestas;
	
	$pos = strpos ($fichero_type, "image");
	if (!$fraseimagen)
	  print('No ha introducido una frase que sirva como ttulo de la imagen<br>');
	elseif (strlen($fraseimagen)>255)
	  print('La frase de la imagen es demasiado larga (mas de 255 caracteres introducidos)<br>');
	elseif (($fichero=='none')||(!$fichero_name))
	{// Si no se manda fichero, este contendra la palabra none
	  print('No se ha enviado ningn fichero.<br>');
	  print('Verifique que el nombre del fichero sea correcto y que no supere el mximo tamao permitido (' .
	        (int)($maxtamimg/1024) . 'KB).<br>');
	}
	elseif (strlen($fichero_name)>255)
	  print('El nombre del fichero es demasiado largo (mas de 255 caracteres introducidos)<br>');
	elseif ($pos === false) // nota: tres signos igual
    	   print('El archivo no se ha reconocido como una imagen. Por defecto se rechaza.');
	else
	{  // Se recibio, pero veamos si podemos almacenarlo 
	   if(!renombra($fichero,$dirimgpropuestas . $fichero_name)) 
	   	return;
	   // Lo hemos almacenado, pero falta ponerlo en la BD
	   $result=crearRegistro('e_gadgets_proimagenes','frase,fichero,user_id',"'$fraseimagen','$fichero_name','$rowUsuario[user_id]'");
	   if(!$result)
	   {
	      print('Fallo en el almacenamiento de la frase <b>'.stripslashes($frase).'</b>');
	      // Intentamos borrar la imagen que se almaceno.
	      // Si hay algun fallo es mejor no intentar remediarlo
	      @unlink($dirimgpropuestas . $fichero_name);
 	      error_sql_traza(__FILE__, __LINE__);
 	      return;
	   }
	   print('El fichero <b>'.$fichero_name.'</b> ha sido recibido con xito.<br>');
	   print('Frase asociada: <b>'.stripslashes($fraseimagen).'</b><br>');
	   print('Tamao del fichero: '.$fichero_size.' bytes ('. (int)($fichero_size/1024) . 'KB).<br>');
	   print('Tipo mime: '.$fichero_type.'<br><br>');
	   print('Gracias por su colaboracin, <b>'.$rowUsuario[username].'</b><br>');
	   print('El equipo administrador estudiar la propuesta lo antes posible y le informar de la decisin tomada.');
	}
}
/*
  Explicacin inicial de lo que puede hacer el usuario.
*/
function explicacion_inicial()
{
	bloque_inicio();
	pendientesModerar();
	salto();

	print('Esta seccin implementa un sistema de propuestas de nuevas frases
		e imgenes espiraleras.<br>
		Si usted lo desea, puede sugerir una frase que contenga las siglas 
		E.S.P.I.R.A.L y/o una imagen que contenga dibujos de espirales.
		Sus propuestas sern almacenadas en la base de datos hasta que
		los administradores les den el visto bueno, momento en el cual
		pasaran a formar parte del conjunto de frases e imgenes que 
		aparecen en la portada principal de Espiral.<br>
	      ');	

	bloque_fin();
	salto();
}
?>