<?php /* 2002.08.17
 * Autor: Vctor P. Arissa <varissa@igijon.com> siguiendo la estructura
 * general de Javier Linares <javier@javierlinares.com>
 * Descripcin: Interfaz de aprobacin de propuestas de gadgets de portada espiraleras
 *
 * Dependencias: include/gadgets, ,
 * includes habituales (sql, general)
*/

/* (c) 2002 La Espiral <info@lawebespiral.org>
 * (c) 2002 Vctor P. Arissa <varissa@igijon.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

/********** Inicio del programa principal gadgetsaprobar.php **********/

require("c:/ARCHIVOS DE PROGRAMA/APACHE GROUP/APACHE/HTDOCS/LAWEBESPIRAL/espiral.php");
$nivelAcceso = "10";
if(($rowUsuario=estasLogeadoBackoffice($nivelAcceso))<0) {
	exit();
}
require("layout.cabecera.php");

// Barra con enlaces
	$nombres[] = 'inicio';
	$enlaces[] = $PHP_SELF;
	$nombres[] = 'aprobar frases';
	$enlaces[] = $PHP_SELF.'?action=mostrar_frases';
	$nombres[] = 'aprobar imgenes';
	$enlaces[] = $PHP_SELF.'?action=mostrar_imagenes';
	$nombres[] = 'frases actuales';
	$enlaces[] = $PHP_SELF.'?action=ver_frases';
	$nombres[] = 'imgenes actuales';
	$enlaces[] = $PHP_SELF.'?action=ver_imagenes';
	$nombres[] = 'sistema de propuesta';
	$enlaces[] = 'gadgetsnuevos.php';
	menu($colorBO1, $colorBO2, "sistema de aprobacin de nuevos gadgets de portada", $PHP_SELF, $nombres, $enlaces, $ruta_imagen, $rowUsuario);

// Control de flujo de las acciones. A partir de aqui va el codigo de la pagina 
	salto(2);
	print('</center>');
	fuente_inicio(2);

	if($action=="mostrar_frases")
	   muestra_frases_para_aprobar();

	elseif($action=="form_borrar_frase")
	   formulario_borrar_frase($idprofrase);

	elseif($action=="borrar_frase_mensaje")
	   borrar_frase_mensaje($razon,$user_email,$idprofrase);

	elseif($action=="aprobar_frases")
	   aprobar_frases($aprobadas);

	elseif($action=="mostrar_imagenes")
	   muestra_imagenes_para_aprobar();

	elseif($action=="form_borrar_imagen")
	   formulario_borrar_imagen($idproimagen);

	elseif($action=="renombrar_imagen")
	   renombrar_imagen($idproimagen,$nuevonombre);

	elseif($action=="form_renombrar_imagen")
	   formulario_renombrar_imagen($idproimagen);

	elseif($action=="borrar_imagen_mensaje")
	   borrar_imagen_mensaje($razon,$user_email,$idproimagen);

	elseif($action=="aprobar_imagenes")
	   aprobar_imagenes($aprobadas);

	elseif ($action=='ver_frases')
	{
	 muestra_frases('e_gadgets_frases','Frases E.S.P.I.R.A.L. actuales');
	 muestra_frases('e_gadgets_profrases','Frases E.S.P.I.R.A.L. propuestas');
	}
	elseif ($action=='ver_imagenes')
	{
	 muestra_imagenes('e_gadgets_imagenes',$dirimgportada,'Imgenes E.S.P.I.R.A.L. actuales');
	 muestra_imagenes('e_gadgets_proimagenes',$dirimgpropuestas,'Imgenes E.S.P.I.R.A.L. propuestas');
	}

	else explicacion_inicial();

	fuente_fin();
	require ("layout.pie.php");
	
/********** Fin del programa principal gadgetsaprobar.php **********/
	
/*******************************************************************
	FUNCIONES GENERALES
*******************************************************************/	
/*
   Introduce una nueva frase propuesta por un usuario en la tabla
de propuestas, siempre y cuando los datos pasados sean correctos.
*/
/*
  Explicacin inicial de lo que puede hacer el usuario.
*/
function explicacion_inicial()
{
	bloque_inicio();
	pendientesModerar();
	salto();
	
	print('Mediante esta seccin podr aprobar o rechazar las frases '.
	      'e imgenes espiraleras que proponen los usuarios de Espiral.');	

	// La semilla debera estar en index.php
	inicializa_semilla_aleatorios();
	print('<br><br>Cada vez que venga a esta pgina obtendr una frase e imagen '.
	      'aleatoria.');
	print('<br><br>'.frase_aleatoria().'<br><br>');
	print('<center>');
	print('<img src="'. imagen_aleatoria($frase) .
   	      '" alt="'. $frase .'"><br>');
   	print($frase . '<br>');
	print('</center>');
	bloque_fin();
	salto();
}
/*******************************************************************
	FUNCIONES DE FRASES
*******************************************************************/	
/*
   Muestra la tabla de frases para aprobar.
   El usuario podra:
   1) Borrar una frase: para ello habr una referencia a esta misma
   pgina pasando como parmetros el identificador de la frase a borrar
   y la accin a realizar, es decir, mostrar el formulario para borrar.
   2) Aprobar un conjunto de frases, usando los checkBox del formulario
*/
function muestra_frases_para_aprobar()
{
 global $db,$PHP_SELF;
 
 $sql='select * from e_gadgets_profrases;';
 $resultfrases=query($sql,$db) or error_sql_traza(__FILE__, __LINE__);
 if (num_rows($resultfrases)==0)
   print('Actualmente no hay propuestas de frases para aprobar.<br>');
 else
 {
   print('<form action="'. $PHP_SELF.'" method="POST" >');
   print('<font face="verdana,arial" size="2">');
   print('<center><table>');
   print('<tr bgCOLOR="#ECD560"><td>Aprobar</td><td>Frase</td><td>Autor</td><td>Borrar</td></tr>');
   while($fila=fetch_array($resultfrases))
   {   
   	print('<tr>');
   	// *** Formulario para aprobar. Pasa los resultados del checkBox
   	// a esta misma pgina con action="aprobar_frases" y los identificadores
   	// en el checkBox
   	print('<td><input type="checkbox" name="aprobadas[]" value="'.$fila[idprofrase].'"></td>'); 
   	print('<td>'.stripslashes($fila[frase]).'</td>');
  	$usuario=sacarInfoUsuario($fila[user_id]);
	if($usuario) print('<td>'.$usuario[username].'</td>');
	else   	     print('<td>annimo</td>');
	
	// *** Referencia para borrar. Llama a esta misma pagina pasndole
	// como action="form_borrar_frase" y el identificador de la frase
	print('<td align="center"><a href="'.$PHP_SELF.'?action=form_borrar_frase&idprofrase='.$fila[idprofrase].'">X</a></td>');
	print('</tr>');
   }
   // *** Formulario para aprobar
   print('<input type="hidden" name="action" value="aprobar_frases">');
   print('<tr><td></td><td>');
   print('<input type="submit" name="B1" value="Aprobar seleccionadas">&nbsp');
   print('<input type="reset" name="B2" value="Limpiar">');
   print('</td><td></td><td></td></tr></table></center>');
   print('</form>');
   salto(2);
 }	
}
/*
  El usuario desea borrar una frase.
  Para ello se presenta un formulario para que se argumenten las razones
  por las cuales se desea borrar dicha frase, y as comunicarsela al
  autor de la frase.
  
  En el caso de que el autor no se encuentre ya en la tabla de usuarios
  se explicar dicho suceso al usuario y se dar la opcin de que la borre
  directamente.
*/
function formulario_borrar_frase($idprofrase)
{
   global $PHP_SELF,$rowUsuario;
 
   // Buscamos la frase  
   $fila=devuelve_fila_profrase($idprofrase);
   if (empty($fila)) return;
   
   // Sacamos la informacin del usuario
   $usuario=sacarInfoUsuario($fila[user_id]);
   if ((!$usuario)||(!$usuario[user_email]))
   {
   	// Borramos la frase directamente
   	$result=eliminaRegistro('e_gadgets_profrases','idprofrase='.$idprofrase) or error_sql_traza(__FILE__, __LINE__);
   	print('La frase <b>'.stripslashes($fila[frase]).'</b> ha sido borrada con xito.<br><br>');

	if(!$usuario)
   	   print('La frase es annima, por lo que no se puede enviar '.
   	         'ningn correo a nadie explicando el motivo del borrado.<br>');
   	else
   	   print('El usuario <b>'.$usuario[username].'</b> no ha proporcionado direccin '.
   	         'de correo electrnico, por lo que no se le podr enviar ningn mensaje.<br>');
   	return;
   }
   // Formulario para borrar
   print('<form action="'. $PHP_SELF.'" method="POST" >');
   print('<font face="verdana,arial" size="2">');
   print('Introduzca el motivo por el cual la frase <b>'.stripslashes($fila[frase]).'</b> ha sido rechazada.<br>');
   print('Se le mandar un correo al usuario que la propuso (<b>'.$usuario[username].'</b>).<br><br>');
   // Variables a mandar por el usuario: razon
   print('<textarea name="razon" cols="60" rows="15">'.
         'Estimado Sr/Sra '.$usuario[username_nombre].' '.$usuario[username_apellidos].
         "\n\n".'Usted nos envo una propuesta de frase E.S.P.I.R.A.L para ser incluida '.
         'en nuestra base de datos. Le informamos que la frase "'.stripslashes($fila[frase]).
         '" ha sido rechazada por el siguiente motivo:'."\n\n<escriba aqu el motivo>\n\n".
         'Atentamente'."\n".
         $rowUsuario[username_nombre].' '.$rowUsuario[username_apellidos].' (La Espiral)'.
         '</textarea><br><br>');
   print('</font>');
   // Variables de Control de flujo para la pagina $PHP_SELF: action, user_email
   print('<input type="hidden" name="action" value="borrar_frase_mensaje">');
   print('<input type="hidden" name="user_email" value="'.$usuario[user_email].'">');
   print('<input type="hidden" name="idprofrase" value="'.$idprofrase.'">');
   print('<input type="submit" name="B1" value="Mandar mensaje y borrar">&nbsp');
   print('</form>');
}
/*
  Dada una frase propuesta que no se desea que sea aceptada,
  se debe de borrar de la tabla y mandar el mensaje
  de aviso a su autor. Dicho mensaje se pasa por parametro
  con $razon, y se manda a la direccin $user_email.
  
  Primero se intenta mandar el correo y, en caso de poder
  mandarse, NO se borra la frase, ya que el autor tiene
  derecho a ser informado de su razn.
  
  Esta politica puede variar.
*/
function borrar_frase_mensaje($razon,$user_email,$idprofrase)
{
	global $rowUsuario,$php_errormsg;
	
	$asunto='Propuesta de frase Espiral rechazada';
	$mensaje=$razon;
	// From y reply-to pongo quien al usuario que lo rechazo o alguna direccion
	// general de la web espiral?
	$cabeceras="From: $rowUsuario[user_email]\n";
	$cabeceras.="Reply-To: $rowUsuario[user_email]\n";
	$cabeceras.="X-Mailer: Web Machine"; 
	// o quizs? $cabeceras.="X-Mailer: PHP/" . phpversion();
	
 	$enviado=@mail("$user_email", $asunto, $mensaje, $cabeceras);
	if(!$enviado)
	   {
	      $explicacion='<b>No se ha podido mandar el correo. La frase no ser borrada</b><br>';
      	      error_email($explicacion,$user_email,$cabeceras,$asunto,$mensaje,$php_errormsg);
	      return;
	   }
	// Ya podemos borrar la frase
	// en este caso no llamamos directamente a  or error_sql_traza(__FILE__, __LINE__);
	// porque hay que avisar del percance de haber enviado el mensaje, pero no borrado
	// la frase.
   	$result=eliminaRegistro('e_gadgets_profrases','idprofrase='.$idprofrase); 
   	if (!$result)
   	{ 
   	   print('Error al borrar la frase!<br>Ojo: <b>El mensaje fue enviado!</b><br>');
   	   // Ahora si informamos, a pesar de tener la linea de error un poco desplazada
   	   error_sql_traza(__FILE__, __LINE__);
   	}
   	else 
   	{
   	   print('La frase ha sido borrada con xito.<br>');
   	   print('El mensaje ha sido enviado con xito.<br><br>');	
   	}
}
/*
  Se desean aprobar un conjunto de propuestas de frases
  pasadas en el array $aprobadas.
*/
function aprobar_frases($aprobadas)
{
   if (empty($aprobadas))
   {
     print('No ha seleccionado ninguna frase para aprobar.');
     return;
   }

   // Por cada una introducimos como nueva, borramos y mandamos mail
   foreach ($aprobadas as $idprofrase)
   {
   	aprueba_frase($idprofrase);
  	print('<hr>');
   }
}
/*
  Dada una propuesta de frase se desea aprobarla. Para ello
hay que:
1) Crear un nuevo registro de frase con los datos de la propuesta de frase.
2) Borrar la propuesta.
3) Mandar un correo de aviso al autor.

Si no se puede crear un nuevo registro, entonces se cancela la operacin
y la propuesta no se borrar para no perderla.
Si la aprobacin se ha realizado (pasos 1 y 2), pero no se puede mandar el
correo de aviso, se mantendrn los pasos anteriores. Ser responsabilidad
del usuario mandar dicho correo, si as lo desea.
*/
function aprueba_frase($idprofrase)
{
   // Buscamos la frase  
   $fila=devuelve_fila_profrase($idprofrase);
   if (empty($fila)) return;
   
   // Introducir como nueva frase
   $result=crearRegistro('e_gadgets_frases','frase,user_id',"'$fila[frase]','$fila[user_id]'");
   if(!$result)
   {
    print('Fallo al almacenar la frase <b>'.stripslashes($fila[frase]).'</b>. '.
          'No ser borrada de las propuestas, ni se mandar mensaje al autor.<br>');
    // Hay que informar de lo que no se podra hacer, y despues indicar el error
    error_sql_traza(__FILE__, __LINE__);
    return;
   }
   // Borrar la antigua propuesta
   $result=eliminaRegistro('e_gadgets_profrases','idprofrase='.$idprofrase);
   if (!$result) 
   {
    print('La frase <b>'.stripslashes($fila[frase]).'</b> se ha introducido como nueva, '.
          'pero ha ocurrido un Error al borrarla '.
          'de propuestas<br>No se mandar mensaje al autor.<br>');
    error_sql_traza(__FILE__, __LINE__);
    return;
   }
   print('La frase <b>'.stripslashes($fila[frase]).'</b> ha sido aceptada correctamente.<br>');
   // Mandar correo
   mensaje_frase_aceptada($fila);
}
/*
  Funcin que se encarga de enviar un mensaje de correo al autor 
  de una propuesta de frase aceptada.
*/
function mensaje_frase_aceptada($fila)
{
 global $rowUsuario,$php_errormsg;

 if (empty($fila))
 {
   print('Error interno: no se han pasado los datos de la propuesta de frase '.
         'para poder construir el correo de aviso al autor de dicha frase.<br>');
   return;
 }
 // Sacamos la informacin del usuario
 $usuario=sacarInfoUsuario($fila[user_id]);
 if(!$usuario)
 {
    print('La frase es annima, por lo que no se puede enviar '.
  	  'ningn correo a nadie explicando que ha sido aceptada.<br>');
    return;
 }
 elseif(empty($usuario[user_email]))
 {
    print('El usuario <b>'.$usuario[username].'</b> no ha proporcionado direccin '.
          'de correo electrnico, por lo que no se le podr enviar ningn mensaje.<br>');
    return;
 }
 $destinatario=$usuario[user_email];
 $mensaje='Estimado Sr/Sra '.$usuario[username_nombre].' '.$usuario[username_apellidos].
         "\n\n".'Usted nos envo una propuesta de frase E.S.P.I.R.A.L para ser incluida '.
         'en nuestra base de datos. Le informamos que la frase "'.stripslashes($fila[frase]).
         '" ha sido aceptada y que pasar a formar parte de las frases que pueden '.
         'aparecer en la portada de la web.'."\n\n".
         'Atentamente'."\n".
         $rowUsuario[username_nombre].' '.$rowUsuario[username_apellidos].' (La Espiral)';
 
 $asunto='Propuesta de frase Espiral rechazada';
 // From y reply-to pongo quien al usuario que lo rechazo o alguna direccion
 // general de la web espiral?
 $cabeceras="From: $rowUsuario[user_email]\n";
 $cabeceras.="Reply-To: $rowUsuario[user_email]\n";
 $cabeceras.="X-Mailer: Web Machine"; 
 // o quizs? $cabeceras.="X-Mailer: PHP/" . phpversion();

 $enviado=@mail($destinatario, $asunto, $mensaje, $cabeceras);
 if(!$enviado)
 {
      $explicacion='<b>No se ha podido mandar el correo.</b><br>';
      error_email($explicacion,$destinatario,$cabeceras,$asunto,$mensaje,$php_errormsg);
      return;
 }
}
/*******************************************************************
	FUNCIONES DE IMAGENES
*******************************************************************/	
/*
   Muestra la tabla de imagenes para aprobar.
   El usuario podr:
   1) Borrar una imagen: para ello habr una referencia a esta misma
   pgina pasando como parmetros el identificador de la imagen a borrar
   y la accin a realizar, es decir, mostrar el formulario para borrar.
   2) Aprobar un conjunto de imagenes, usando los checkBox del formulario
*/
function muestra_imagenes_para_aprobar()
{
 global $db,$PHP_SELF,$dirimgpropuestas;
 
 $sql='select * from e_gadgets_proimagenes;';
 $resultimagenes=query($sql,$db) or error_sql_traza(__FILE__, __LINE__);
 if (num_rows($resultimagenes)==0)
   print('Actualmente no hay propuestas de imgenes para aprobar.<br>');
 else
 {
   print('<form action="'. $PHP_SELF.'" method="POST" >');
   print('<font face="verdana,arial" size="2">');
   print('<center><table>');
   print('<tr bgCOLOR="#ECD560"><td>Aprobar</td><td>Imagen</td><td>Frase, autor y fichero</td><td>Borrar</td><td>Renombrar</td></tr>');
   while($fila=fetch_array($resultimagenes))
   {   
   	// *** Formulario para aprobar. Pasa los resultados del checkBox
   	// a esta misma pgina con action="aprobar_imagenes" y los identificadores
   	// en el checkBox. Tambien ocupar 3 filas.
   	print('<tr><td rowspan="3" ><input type="checkbox" name="aprobadas[]" value="'.$fila[idproimagen].'"></td>'); 
   	// La imagen ocupa 3 filas. Poner la segunda celda como imagen y
   	// la tercera con la frase
   	print('<td rowspan="3" align="center"><img src="'. $dirimgpropuestas. $fila[fichero] .
   	      '" alt="'.stripslashes($fila[frase]).'"></td>');
   	print('<td align="center">'.stripslashes($fila[frase]).'</td>');
	// *** Referencia para borrar. Llama a esta misma pagina pasndole
	// como action="form_borrar_imagen" y el identificador de la imagen
	// ser la cuarta columna
	print('<td rowspan="3" align="center"><a href="'.$PHP_SELF.'?action=form_borrar_imagen&idproimagen='.$fila[idproimagen].'">X</a></td>');
	// *** Referencia para modificar el nombre del fichero. Llama a esta misma pagina pasndole
	// como action="form_renombrar_imagen" y el identificador de la imagen
	// ser la quinta columna
	print('<td rowspan="3" align="center"><a href="'.$PHP_SELF.'?action=form_renombrar_imagen&idproimagen='.$fila[idproimagen].'">R</a></td>');
	print('</tr>');
   	// Segunda fila, la 1 y 2 celdas sigue siendo el check y la imagen (no hace falta ponerla),
   	// La tercera celda es el autor
  	$usuario=sacarInfoUsuario($fila[user_id]);
	if($usuario) print('<tr><td align="center">Mandada por: '.$usuario[username].'</td></tr>');
	else   	     print('<tr><td align="center">annimo</td></tr>');
	// Tercera fila, la 1 y 2 celdas sigue siendo el check y la imagen (no hace falta ponerla),
	// la tercera celda es el nombre del fichero
	print('<tr><td align="center">Nombre del fichero: '.$fila[fichero].'</td></tr>');
   }
   // *** Formulario para aprobar
   print('<input type="hidden" name="action" value="aprobar_imagenes">');
   print('<tr><td></td><td>');
   print('<input type="submit" name="B1" value="Aprobar seleccionadas">&nbsp');
   print('<input type="reset" name="B2" value="Limpiar">');
   print('</td><td></td><td></td></tr></table></center>');
   print('</form>');
   salto(2);
 }	
}
/*
  El usuario desea renombrar una imagen.
  Se le muestran algunos de sus datos y se le 
  facilita un formulario para ello.
*/
function formulario_renombrar_imagen($idproimagen)
{
   global $PHP_SELF,$dirimgpropuestas;
 
   // Buscamos la imagen
   $fila=devuelve_fila_proimagen($idproimagen);
   if (empty($fila)) return;
   
   // Formulario para renombrar
   print('<form action="'. $PHP_SELF.'" method="POST" >');
   print('<font face="verdana,arial" size="2">');
   print('Fichero <b>'.$fila[fichero].'</b><br>');
   print('Frase asociada <b>'.$fila[frase].'</b><br>');
   print('<img src="'. $dirimgpropuestas. $fila[fichero] .'" alt="'.$fila[frase].'"><br><br>');   
   print('Introduzca el nuevo nombre del fichero de la imagen propuesta:<br>');
   // Variables a mandar por el usuario: nuevonombre
   print('<input type="text" name=nuevonombre value="'.$fila[fichero].'"><br><br>');
   print('</font>');
   // Variables de Control de flujo para la pagina $PHP_SELF: action, idproimagen
   print('<input type="hidden" name="action" value="renombrar_imagen">');
   print('<input type="hidden" name="idproimagen" value="'.$idproimagen.'">');
   print('<input type="submit" name="B1" value="Renombrar">&nbsp');
   print('<input type="reset" name="B2" value="Limpiar">&nbsp');
   print('</form>');
}
/*
  Funcion que dado el nuevo nombre de una imagen propuesta
  le cambia el nombre del archivo en:
  1) La base de datos.
  2) El directorio de propuestas.
*/
function renombrar_imagen($idproimagen,$nuevonombre)
{
   global $dirimgpropuestas;
   
   // Buscamos la imagen
   $fila=devuelve_fila_proimagen($idproimagen);
   if (empty($fila)) return;   
   
   elseif (empty($nuevonombre))
   {
     print('No ha introducido un nuevo nombre.<br>');
     return;
   }
   elseif (strlen($nuevonombre)>255)
   {
     print('El nombre del fichero es demasiado largo (mas de 255 caracteres introducidos)<br>');
     return;
   }
   elseif($fila[fichero]==$nuevonombre)
   {
   	print('Ha introducido el mismo nombre que tena antes.<br>');
   	return;
   }
   // Renombramos el fichero en el directorio
   $origen=$dirimgpropuestas . $fila[fichero];
   $destino=$dirimgpropuestas . $nuevonombre;
   if(!renombra($origen, $destino))
   	return;
   	
   // Modificar en la base de datos. No hacemos todava error_sql pq
   // hay tratamiento de errores
   $result=actualizaCampo('fichero', $nuevonombre, 'e_gadgets_proimagenes', 
                          'idproimagen='.$idproimagen);
   if(!$result)
   {
    print('Fallo al renombrar la imagen <b>'.$fila[fichero].'</b>. '.
    	  'por <b>'.$nuevonombre.'</b>.<br>');
    // Deshacer el traspase, y si no es posible avisar
    if(!renombra($destino,$origen))
       print('<b>Atencin</b>: el fichero ya se ha renombrado en el directorio de propuestas ('.
             $dirimgpropuestas.'), pero no se ha reflejado el cambio en la base de datos, '.
             'ni tampoco se ha podido volver a renombrarlo al antiguo nombre.<br>'.
             'Deber de hacerlo manualmente y comprobar la consistencia con '.
             'la base de datos.');
    error_sql_traza(__FILE__, __LINE__);
    return;
   }
   print('El fichero ha sido renombrado con exito.<br>');
}
/*
   Borra el fichero especificado en la fila de la base de datos
   e_gadgets_proimagenes que se pasa por parmetro.
   
   Primero se borra la fila de la base de datos, y despues el
   fichero en el directorio especificado. Lo importante
   es mantener la consistencia entre la informacin de la BD
   y los ficheros encontrados en los directorios.
   
   De esta manera, si falla el borrado de la BD, no se realiza la
   del fichero y todo queda como estaba (correcto).
   
   Si falla el borrado de la imagen, del fichero, es porque este
   no se encuentra (con lo que igualmente queda consistente
*/
function borrar_imagen_BD_fichero($idproimagen)
{
 	global $dirimgpropuestas;

   	// Buscamos la imagen
   	$fila=devuelve_fila_proimagen($idproimagen);
   	if (empty($fila)) return;

   	// Borramos la imagen directamente
   	// Primero la fila de la base de datos
   	$result=eliminaRegistro('e_gadgets_proimagenes','idproimagen='.$idproimagen);
   	if (!$result)
   	{
   	   print('Error al borrar la imagen en la base de datos. <b>El fichero no ser borrado del servidor</b><br><br>');
   	   // Informamos un poco despues del error pq hay que indicar el mensaje de arriba
   	   error_sql_traza(__FILE__, __LINE__);
   	   return;
   	}
   	// Y ahora borramos el fichero
   	$exito=@unlink($dirimgpropuestas . $fila[fichero]);
   	if(!exito) 
   	{
   	   print('Error grave: la imagen <b>'.$fila[fichero].'</b> ha sido borrada correctamente de la base de datos, '.
   	         'pero ha habido un fallo al borrar el fichero en la ruta '.
   	         $dirimgpropuestas . $fila[fichero] . '<br>');
	   if ($php_errormsg)
	     print('Razn: '.$php_errormsg . '.<br>');
   	   print('Deber borrar manualmente dicho fichero, si es que existe.<br>');    
   	   return;
   	}
   	print('La imagen <b>'.$fila[fichero].'</b> ha sido borrada con xito.<br><br>');
}	
/*
  El usuario desea borrar una imagen.
  Para ello se presenta un formulario para que se argumenten las razones
  por las cuales se desea borrar dicha imagen, y as comunicarsela al
  autor de la imagen.
  
  En el caso de que el autor no se encuentre ya en la tabla de usuarios
  se explicar dicho suceso al usuario y se dar la opcin de que la borre
  directamente.
*/
function formulario_borrar_imagen($idproimagen)
{
   global $PHP_SELF,$rowUsuario;
 
   // Buscamos la imagen
   $fila=devuelve_fila_proimagen($idproimagen);
   if (empty($fila)) return;
   
   // Sacamos la informacin del usuario
   $usuario=sacarInfoUsuario($fila[user_id]);
   if ((!$usuario)||(!$usuario[user_email]))
   {
	if(!$usuario)
   	   print('La imagen es annima, por lo que no se puede enviar '.
   	         'ningn correo a nadie explicando el motivo del borrado.<br>');
   	else
   	   print('El usuario <b>'.$usuario[username].'</b> no ha proporcionado direccin '.
   	         'de correo electrnico, por lo que no se le podr enviar ningn mensaje.<br>');
   	
   	// Como no hay que mandar mensaje, se borra directamente
	borrar_imagen_BD_fichero($idproimagen);
   	return;
   }
   // Formulario para borrar
   print('<form action="'. $PHP_SELF.'" method="POST" >');
   print('<font face="verdana,arial" size="2">');
   print('Introduzca el motivo por el cual la imagen <b>'.$fila[fichero].'</b> ha sido rechazada.<br>');
   print('Se le mandar un correo al usuario que la propuso (<b>'.$usuario[username].'</b>).<br><br>');
   // Variables a mandar por el usuario: razon
   print('<textarea name="razon" cols="60" rows="15">'.
         'Estimado Sr/Sra '.$usuario[username_nombre].' '.$usuario[username_apellidos].
         "\n\n".'Usted nos envo una propuesta de imagen E.S.P.I.R.A.L para ser incluida '.
         'en nuestra base de datos. Le informamos que la imagen '.$fila[fichero].
         ', cuya frase asociada es "'.stripslashes($fila[frase]).
         '", ha sido rechazada por el siguiente motivo:'."\n\n<escriba aqu el motivo>\n\n".
         'Atentamente'."\n".
         $rowUsuario[username_nombre].' '.$rowUsuario[username_apellidos].' (La Espiral)'.
         '</textarea><br><br>');
   print('</font>');
   // Variables de Control de flujo para la pagina $PHP_SELF: action, user_email
   print('<input type="hidden" name="action" value="borrar_imagen_mensaje">');
   print('<input type="hidden" name="user_email" value="'.$usuario[user_email].'">');
   print('<input type="hidden" name="idproimagen" value="'.$idproimagen.'">');
   print('<input type="submit" name="B1" value="Mandar mensaje y borrar">&nbsp');
   print('</form>');
}
/*
  Dada una imagen propuesta que no se desea que sea aceptada,
  se debe de borrar de la tabla, del directorio y mandar el mensaje
  de aviso a su autor. Dicho mensaje se pasa por parametro
  con $razon, y se manda a la direccin $user_email.
  
  Primero se intenta mandar el correo y, en caso de poder
  mandarse, NO se borra la frase, ya que el autor tiene
  derecho a ser informado de su razn.
  Segundo se borra del directorio y de la base de datos.
  
  Si hay problemas con la eliminacion de la BD, el autor
  recibir ms de un correo hasta que sea realmente eliminada,
  pero esto nos da igual.
  
  Esta politica puede variar.
*/
function borrar_imagen_mensaje($razon,$user_email,$idproimagen)
{
	global $rowUsuario,$php_errormsg;
	
	$asunto='Propuesta de imagen Espiral rechazada';
	$mensaje=$razon;
	// From y reply-to pongo quien al usuario que lo rechazo o alguna direccion
	// general de la web espiral?
	$cabeceras="From: $rowUsuario[user_email]\n";
	$cabeceras.="Reply-To: $rowUsuario[user_email]\n";
	$cabeceras.="X-Mailer: Web Machine"; 
	// o quizs? $cabeceras.="X-Mailer: PHP/" . phpversion();
	
 	$enviado=@mail("$user_email", $asunto, $mensaje, $cabeceras);
	if(!$enviado)
	   {
	      $explicacion='<b>No se ha podido mandar el correo. La imagen no ser borrada</b><br>';
      	      error_email($explicacion,$user_email,$cabeceras,$asunto,$mensaje,$php_errormsg);
	      return;
	   }
	// Ya podemos borrar la frase
	borrar_imagen_BD_fichero($idproimagen);
}
/*
  Se desean aprobar un conjunto de propuestas de imagenes
  pasadas en el array $aprobadas.
*/
function aprobar_imagenes($aprobadas)
{
   if (empty($aprobadas))
   {
     print('No ha seleccionado ninguna imagen para aprobar.');
     return;
   }

   // Por cada una introducimos como nueva, borramos y mandamos mail
   foreach ($aprobadas as $idproimagen)
   {
   	aprueba_imagen($idproimagen);
  	print('<hr>');
   }
}
/*
  Dada una propuesta de imagen se desea aprobarla. Para ello
hay que:
0) Mover la imagen.
1) Crear un nuevo registro de imagen con los datos de la propuesta de imagen.
2) Borrar la propuesta.
3) Mandar un correo de aviso al autor.

Si no puedes mover la imagen
Si no se puede crear un nuevo registro, entonces se cancela la operacion
y la propuesta no se borrara para no perderla.
Si la aprobacion se ha realizado (pasos 1 y 2), pero no se puede mandar el
correo de aviso, se mantendrn los pasos anteriores. Ser responsabilidad
del usuario mandar dicho correo, si asi lo desea.
*/
function aprueba_imagen($idproimagen)
{
   global $dirimgportada,$dirimgpropuestas;
   // Buscamos la imagen
   $fila=devuelve_fila_proimagen($idproimagen);
   if (empty($fila)) return;   

   // Movemos el fichero
   $origen=$dirimgpropuestas . $fila[fichero];
   $destino=$dirimgportada . $fila[fichero];
   if(!renombra($origen, $destino))
   	return;
   	
   // Introducir como nueva imagen de portada
   $result=crearRegistro('e_gadgets_imagenes','frase,fichero,user_id',"'$fila[frase]','$fila[fichero]','$fila[user_id]'");
   if(!$result)
   {
    print('Fallo al almacenar la imagen <b>'.$fila[fichero].'</b>. '.
          'No ser borrada de las propuestas, ni se mandar mensaje al autor.<br><br>');
    // Deshacer el traspase, y si no es posible avisar
    if(!renombra($destino,$origen))
       print('<b>Atencin</b>: el fichero ya se ha movido del directorio de propuestas ('.
             $dirimgpropuestas.') al directorio de imagenes aceptadas ('.
             $dirimgportada.'), pero no se ha reflejado el cambio en la base de datos, '.
             'ni tampoco se ha podido volver a situar el archivo en el directorio de '.
             'propuestas. Deber de hacerlo manualmente y comprobar la consistencia con '.
             'la base de datos.<br>');
    // informamos tardiamente pq hay tratamiento de errores
    error_sql_traza(__FILE__, __LINE__);
    return;
   }
   // Borrar la antigua propuesta
   $result=eliminaRegistro('e_gadgets_proimagenes','idproimagen='.$idproimagen);
   if (!$result) 
   {
    print('Error al borrar la imagen de propuestas <b>'.$fila[fichero].'</b>.'.
          '<br>No se mandar mensaje al autor.<br>');
    print('<b>Atencin</b>: la imagen ya ha sido incluida como nueva en la portada, '.
          'y el archivo se ha trasladado. Deber borrarlo manualmente en la base de datos.<br><br>');
    // informamos tardiamente pq hay q avisar de lo de arriba
    error_sql_traza(__FILE__, __LINE__);
    return;
   }
   print('La imagen <b>'.$fila[fichero].'</b> ha sido aceptada correctamente.<br>');
   // Mandar correo
   mensaje_imagen_aceptada($fila);
}
/*
  Funcin que se encarga de enviar un mensaje de correo al autor 
  de una propuesta de imagen aceptada.
*/
function mensaje_imagen_aceptada($fila)
{
 global $rowUsuario,$php_errormsg;

 if (empty($fila))
 {
   print('Error interno: no se han pasado los datos de la propuesta de imagen '.
         'para poder construir el correo de aviso al autor de dicha imagen.<br>');
   return;
 }
 // Sacamos la informacin del usuario
 $usuario=sacarInfoUsuario($fila[user_id]);
 if(!$usuario)
 {
    print('La imagen es annima, por lo que no se puede enviar '.
  	  'ningn correo a nadie explicando que ha sido aceptada.<br>');
    return;
 }
 elseif(empty($usuario[user_email]))
 {
    print('El usuario <b>'.$usuario[username].'</b> no ha proporcionado direccin '.
          'de correo electrnico, por lo que no se le podr enviar ningn mensaje.<br>');
    return;
 }
 $destinatario=$usuario[user_email];
 $mensaje='Estimado Sr/Sra '.$usuario[username_nombre].' '.$usuario[username_apellidos].
         "\n\n".'Usted nos envo una propuesta de imagen E.S.P.I.R.A.L para ser incluida '.
         'en nuestra base de datos. Le informamos que la imagen "'.$fila[fichero].', '.
         'cuya frase asociada es '.stripslashes($fila[frase]).', '.
         '" ha sido aceptada y que pasar a formar parte de las imagenes que pueden '.
         'aparecer en la portada de la web.'."\n\n".
         'Atentamente'."\n".
         $rowUsuario[username_nombre].' '.$rowUsuario[username_apellidos].' (La Espiral)';
 
 $asunto='Propuesta de imagen Espiral rechazada';
 // From y reply-to pongo quien al usuario que lo rechazo o alguna direccion
 // general de la web espiral?
 $cabeceras="From: $rowUsuario[user_email]\n";
 $cabeceras.="Reply-To: $rowUsuario[user_email]\n";
 $cabeceras.="X-Mailer: Web Machine"; 
 // o quizs? $cabeceras.="X-Mailer: PHP/" . phpversion();
	
 $enviado=@mail($destinatario, $asunto, $mensaje, $cabeceras);
 if(!$enviado)
 {
      $explicacion='<b>No se ha podido mandar el correo.</b><br>';
      error_email($explicacion,$destinatario,$cabeceras,$asunto,$mensaje,$php_errormsg);
      return;
 }
}

?>